#define ApplyForce
f = argument0;
fd = argument1;

xsp = lengthdir_x(f,fd)+lengthdir_x(speed,direction);
ysp = lengthdir_y(f,fd)+lengthdir_y(speed,direction);

speed = point_distance(x,y,x+xsp,y+ysp);
direction = point_direction(x,y,x+xsp,y+ysp);

#define CreatePendulum
/***************************************************
  argument0 = attached object
  argument1 = gravity
  argument2 = friction
  argument3 = mass
 ***************************************************/

o = instance_nearest(x,y,argument0);
g = argument1;
fr = argument2;
m = argument3;

l = point_distance(x,y,o.x,o.y);


#define MovePendulum
/***************************************************
  No arguments.
 ***************************************************/

if (m<>0) {

ApplyForce(g/m,270);
if (speed > 0 and speed > fr*speed/m) or (speed < 0 and speed < fr*speed/m) {
  speed -= fr*speed/m;
}
else {
  speed = 0;
}

}

ApplyForce(point_distance(x,y,o.x,o.y)-l,point_direction(x,y,o.x,o.y));

x+=lengthdir_x(point_distance(x,y,o.x,o.y)-l,point_direction(x,y,o.x,o.y));
y+=lengthdir_y(point_distance(x,y,o.x,o.y)-l,point_direction(x,y,o.x,o.y));

#define DrawPendulum
draw_line(o.x,o.y,x,y);

